module AnalyticsPSW
  module Dimensions

    def create_dimension(name, data_type, units = '', description = '')
      body = create_json_body('dimension', {:name => name.to_s, :description => description, :data_type => data_type, :units => units})
      resp = http_request(:post, "#{@service_location}/dimensions", nil, body)
      @dimensions |= [name.to_s] if resp['status'] && [200, 201, 202].include?(resp['status'])
      resp
    end

    def list_dimensions
      http_request(:get, "#{@service_location}/dimensions")
    end

    def show_dimension_resources(dimension_name)
      http_request(:get, "#{@service_location}/dimensions/#{dimension_name}")
    end

    def show_dimension_metadata(dimension_name)
      http_request(:get, "#{@service_location}/dimensions/#{dimension_name}/metadata")
    end

    private

    def find_or_create_dimensions(dimensions)
      all_dimensions = get_dimension_names
      dimensions.each do |dimension|
        dimension.each do |name, data_type|
          unless all_dimensions.include?(name)
            create_dimension(name, data_type)
            all_dimensions << name
          end
        end
      end
      @dimensions = all_dimensions
    end

    def get_dimension_names
      dimensions = list_dimensions['body']['dimensions']
      dimensions ? dimensions.map { |d| d['name']} : []
    end
  end
end
