module AnalyticsPSW
  module EventTypes

    def create_event_type(name, description = "")
      body = create_json_body('event_type', {:name => name.to_s, :description => description})
      event_type_response = http_request(:post, "#{@service_location}/event_types", nil, body)
      @event_types |= [name.to_s] if event_type_response['status'] && [200, 201, 202].include?(event_type_response['status'])
      event_type_response
    end

    def list_event_types
      http_request(:get, "#{@service_location}/event_types")
    end

    def show_event_type(event_name)
      http_request(:get, "#{@service_location}/event_types/#{event_name.to_s}")
    end

    private

    def find_or_create_event_types
      all_event_types = get_event_names
      new_events = @event_types - all_event_types
      new_events.each do |event_type|
        create_event_type(event_type)
      end
      @event_types |= all_event_types
    end

    def get_event_names
      event_types = list_event_types['body']['event_types']
      event_types ? event_types.map{|e| e['name']} : []
    end

  end
end
