require 'active_model'

class AnalyticsReport
  if defined?(ActiveModel::Model)
    include ActiveModel::Model
  else
    extend ActiveSupport::Concern
    include ActiveModel::Validations
    include ActiveModel::Conversion

    included do
      extend ActiveModel::Naming
      extend ActiveModel::Translation
    end

    def initialize(params={})
      params.each do |attr, value|
        self.public_send("#{attr}=", value)
      end if params

      super()
    end
  end

  # :rows is an array of hashes where each hash is a row containing AnalyticsReportField objects
  attr_accessor :status, :rows, :error_message
end
