require 'active_model'

class AnalyticsReportField
  if defined?(ActiveModel::Model)
    include ActiveModel::Model
  else
    extend ActiveSupport::Concern
    include ActiveModel::Validations
    include ActiveModel::Conversion

    included do
      extend ActiveModel::Naming
      extend ActiveModel::Translation
    end

    def initialize(params={})
      params.each do |attr, value|
        self.public_send("#{attr}=", value)
      end if params

      super()
    end
  end

  attr_accessor :name, :value, :is_aggregate

  def to_s
    @value.to_s
  end

  def sum
    @value['sum'].present? ? @value['sum'] : 0
  end

  def avg
    @value['avg'].present? ? @value['avg'] : 0
  end

  def stddev
    @value['stddev'].present? ? @value['stddev'] : 0
  end

end
